<?php
// ----------------------------------------------------------------------
// File: $Id: block-Modules.php,v 1.4 2003/12/17 17:11:14 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * block-Modules.php
 *
 * Diese Datei stellt den Block Modules dar.
 *
 * @author Hinrich Donner
 * @author F. Bruzi
 * @version 0.2
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage Blcke
 * @category Navigation
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

$author             =& vkpAdmin::GetInstance();
$modules            =& vkpModules::GetInstance();
$bag_active         = array();
$bag_inactive       = array();

// Alle Module durchgehen
//
foreach ($modules as $module)
{
    // Wenn das Modul gelscht wurde, ignorieren
    //
    if (!$module->Exists())
        continue;

    // Wenn es ein aktives Modul ist, dann...
    //
    if ($module->active)
    {
        // ... die Zugriffsberechtigung prfen
        //
        switch ($module->view)
        {
            case 0:
                $bag_active[] = $module->title;
                break;

            case 1:
                if (vkpUserLoggedIn() || $author->logged_in)
                    $bag_active[] = $module->title;
                break;

            case 2:
                if ($author->logged_in)
                    $bag_inactive[] = $module->title;
                break;
        }
    }
    // Wenn es ein inaktives Modul ist, dann wird es nur dem Admin angezeigt
    elseif ($author->HasFlag('modules'))
            $bag_inactive[] = $module->title;
}

// Ausgabe vorbereiten
//
require_once VKP_INCLUDE_DIR . '/vkphtml.php';
$content .= '<table cellpadding="0" cellspacing="0" border="0">' . "\n"
    . "<tr>\n"
    . "<td valign=\"top\" nowrap><big>" . vkpHtmlBold('&middot;') . vkpHtmlSpace() . "</big></td>\n"
    . "<td valign=\"top\"><a href=\"index.php\">" . _HOME . "</a></td>\n"
    . "</tr>\n";

// Aktive Module zusammenstellen
//
foreach ($bag_active as $menu_title)
    $content .= "<tr>\n"
        . "<td valign=\"top\" nowrap><big>" . vkpHtmlBold('&middot;') . vkpHtmlSpace() . "</big></td>\n"
        . "<td valign=\"top\">"
        . "<a href=\"" . $modules->$menu_title->GetUri() . "\">"
        . ((empty($modules->$menu_title->custom_title))
                ? $modules->$menu_title->title
                : $modules->$menu_title->custom_title)
        . "</a>"
        . "</td>\n"
        . "</tr>\n";

// Nun die inaktiven Module
//
if ($author->HasFlag('modules'))
{
    $content .= "<td colspan=\"2\" align=\"center\">" . vkpHtmlSpace()
        . "</td>\n"
        . "</tr>\n"
        . "<tr>\n"
        . "<td colspan=\"2\" align=\"center\">" . vkpHtmlSpan(_NOACTIVEMODULES, 'option') . vkpHtmlLf()
        . vkpHtmlSpan(_FORADMINTESTS, 'tiny') . "</td>\n"
        . "</tr>\n"
        . "<td colspan=\"2\" align=\"center\">" . vkpHtmlSpace()
        . "</td>\n"
        . "</tr>\n";
    if (count($bag_inactive) == 0)
        $content .= "<tr>\n"
            . "<td colspan=\"2\" align=\"center\">" . vkpHtmlItalic(_NONE)
            . "</td>\n"
            . "</tr>\n";
    else
        foreach ($bag_inactive as $menu_title)
            $content .= "<tr>\n"
                . "<td valign=\"top\" nowrap><big>" . vkpHtmlBold('&middot;') . vkpHtmlSpace() . "</big></td>\n"
                . "<td valign=\"top\">"
                . "<a href=\"" . $modules->$menu_title->GetUri() . "\">"
                . ((empty($modules->$menu_title->custom_title))
                        ? $modules->$menu_title->title
                        : $modules->$menu_title->custom_title)
                . "</a>"
                . "</td>\n"
                . "</tr>\n";
}

// Tabelle schlieen
//
$content .= "</table>\n";

// $Log: block-Modules.php,v $
// Revision 1.4  2003/12/17 17:11:14  hdonner
// - Anpassung an die Klasse vkpModules
//
// Revision 1.3  2003/11/20 21:20:53  hdonner
// - Fix: Inaktive Module fehlten
//
// Revision 1.2  2003/11/16 12:00:33  hdonner
// - Queries weitestgehend entfernt
// - PHP_SELF entfernt
//
//
?>
