<?php
// ----------------------------------------------------------------------
// File: $Id: vkpadmin.php,v 1.3 2004/01/10 11:29:36 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * vkpadmin.php
 *
 * Diese Datei enthlt die Klasse vkpAdmin.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API (Klassen)
 * @category Autoren
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * __VKP_ADMIN_INSTANCE
 *
 * Der Name der globalen Variablen, die die Instance enthlt.
 *
 * @access private
 * @see vkpAdmin
 */
define('__VKP_ADMIN_INSTANCE', '__vkp_admin_instance');

/**
 * Klasse vkpAdmin
 *
 * Diese Klasse enthlt die notwendigen Methoden fr die Zugriffe auf
 * die Eigenschaften des aktuellen Autors.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 */
class vkpAdmin
{
    /**
     * logged_in
     *
     * Enthlt den Status des aktuellen Benutzers.
     *
     * @var bool
     * @access public
     */
    var $logged_in = false;

    /**
     * details
     *
     * Enthlt die Eigenschaften des aktuellen Administrators, wenn er
     * angemeldet ist, sonst eine leeres Array.
     *
     * @var array
     * @access public
     */
    var $details;

    /**
     * vkpAdmin
     *
     * Konstruktor
     *
     * @access protected
     * @see vkpAdmin::GetInstance()
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function vkpAdmin()
    {
        $this->Init();
        if ($this->_LoginBySession())
            return;
        if ($this->_LoginByCookie())
            return;
    }

    /**
     * GetInstance
     *
     * Liefert eine Referenz auf die Instanz der Klasse. Diese Funktion sollte unbedingt
     * anstelle des Konstruktors benutzt werden, da so sichergestellt wird, dass nur eine
     * Instanz angelegt wird.
     *
     * @return vkpAdmin Die Referenz
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function &GetInstance()
    {
        if (!array_key_exists(__VKP_ADMIN_INSTANCE, $GLOBALS) || !is_a($GLOBALS[__VKP_ADMIN_INSTANCE], 'vkpAdmin'))
            $GLOBALS[__VKP_ADMIN_INSTANCE] =& new vkpAdmin();
        return $GLOBALS[__VKP_ADMIN_INSTANCE];
    }

    /**
     * LoadById
     *
     * Ld einen Datensatz, wobei die Id (oder besser 'aid') als Suchkriterium verwendet
     * wird.  Es besteht im Normallfall keine Notwendigkeit, diese Methode zu benutzen.
     *
     * @param string $id Die aid
     * @param string $passwd Das Kennwort
     * @param bool $crypted Wenn TRUE, dann ist das bergebene Kennwort verschlsselt
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function LoadById($id, $passwd, $crypted = true)
    {
        if (!$crypted)
            $passwd = md5($passwd);
        $config =& vkpConfig::GetInstance();
        $sql    = "SELECT *
                   FROM `" . $config->prefix . "_authors`
                   WHERE ((`aid`='" . vkpVarPrepForStore(substr($id, 0, 25)) . "')
                         AND (`pwd`='" . vkpVarPrepForStore($passwd) . "'))";
        $dbr    = sql_query($sql);
        $result = sql_fetch_array($dbr);
        sql_free_result($dbr);
        return $result;
    }

    /**
     * _LogInBySession
     *
     * Diese Methode prft, ob eine Session-Variable mit der Id existiert. Falls ja,
     * wird der zugehrige Datensatz geladen.
     *
     * @return bool
     * @access protected
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function _LoginBySession()
    {
        $session =& psSession::GetInstance();
        if (!$session->Exists('__vkp_admin_id') || !$session->Exists('__vkp_admin_passwd'))
            return false;
        $this->Free();
        $this->Init($this->LoadById($session->Get('__vkp_admin_id'),
                                    $session->Get('__vkp_admin_passwd')));
        return true;
    }

    /**
     * _LogInByCookie
     *
     * Diese Methode prft, ob ein gltiges Cookie vorhanden ist. Falls ja, wird ein Login
     * durchgefhrt.
     *
     * @return bool
     * @access protected
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function _LoginByCookie()
    {
        $config =& vkpConfig::GetInstance();
        if (!vkpCookieExists('admin'))
            return false;
        $admin = vkpCookieGet('admin');
        $admin = base64_decode($admin);
        list($id,
             $passwd,
             $language) = explode(':', $admin);
        $details = $this->LoadById($id, $passwd);
        if (empty($details)
                || empty($passwd)
                || !is_array($details)
                || !array_key_exists('pwd', $details)
                || ($passwd !== $details['pwd']))
            return false;
        $this->Free();
        $this->Init($details);
        $this->UpdateSession();

        // Cookie erneuern
        //
        $logout = vkpVarCleanFromInput('adminlogout');
        if (empty($logout))
            vkpCookieSet('admin',
                         base64_encode($admin),
                         $config->admin_cookie_lifetime);
        return true;
    }

    /**
     * Login
     *
     * Fhrt ein Login durch, sofern dieses mglich ist.  Im Erfolgsfall kehrt diese
     * Methode nicht zurck, sondern lst eine Weiterleitung aus.
     *
     * @param string $id Die aid des Autors
     * @param string $passwd Dass Kennwort
     * @param bool $use_cookie Wenn TRUE wird ein Cookie gesetzt
     * @return bool FALSE, wenn der Login gescheitert ist
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function Login($id, $passwd, $use_cookie)
    {
        if (false === ($details = $this->LoadById($id, $passwd, false)))
            return false;

        $this->Free();
        $this->Init($details);
        $this->UpdateSession();
        $config =& vkpConfig::GetInstance();

        // Ggf. Cookie setzen
        //
        if ($config->admin_cookie_required || $use_cookie)
        {
            $admin = $this->GetId() . ':' . $this->GetPasswd() . ':' . $this->GetLanguage();
            vkpCookieSet('admin',
                         base64_encode($admin),
                         $config->admin_cookie_lifetime);
        }

        // Und zur Admin-bersicht
        //
        vkpLocation('admin.php');
    }

    /**
     * Logout
     *
     * Fhrt ein Logout durch und springt zur Startseite.
     *
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function Logout()
    {
        $this->Clear();
        $this->UpdateSession();
        vkpCookieDelete('admin');
        vkpLocation();
    }

    /**
     * UpdateSession
     *
     * Diese Methode aktualisiert die Session-Daten.
     *
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function UpdateSession()
    {
        $session =& psSession::GetInstance();
        if ($this->LoggedIn())
        {
            $session->Set('__vkp_admin_id', $this->GetId());
            $session->Set('__vkp_admin_passwd', $this->GetPasswd());
        }
        else
        {
            $session->Delete('__vkp_admin_id');
            $session->Delete('__vkp_admin_passwd');
        }
    }

    /**
     * Free
     *
     * Diese Methode gibt den belegten Speicher frei.
     *
     * @see vkpAdmin::Init(), vkpAdmin::Clear()
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function Free()
    {
        unset($this->details);
        $this->logged_in = false;
    }

    /**
     * Init
     *
     * Diese Methode initialisiert den Speicherbereich.
     *
     * @param array $source Der zu kopierende Datensatz
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpAdmin::Free(), vkpAdmin::Clear()
     */
    function Init($source = array())
    {
        $this->details = $source;
        if (is_array($source) && array_key_exists('aid', $source))
        {
            // Eigenschaften erzeugen
            //
            foreach ($this->details as $name => $value)
                $this->$name = $value;

            $this->logged_in = true;
        }
        else
            $this->logged_in = false;
    }

    /**
     * Clear
     *
     * Diese Methode lscht die bisherigen Daten und initialisiert den
     * Datensatz.
     *
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpAdmin::Init(), vkpAdmin::Free()
     */
    function Clear()
    {
        $this->Free();
        $this->Init();
    }

    /**
     * LoggedIn
     *
     * Diese Methode liefert den Wert der Eigenschaft logged_in
     *
     * @return bool
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpAdmin::$logged_in
     */
    function LoggedIn()
    {
        return $this->logged_in;
    }

    /**
     * GetAllAsReference
     *
     * Liefert eine Reference auf die Eigenschaft details
     *
     * @return array
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpAdmin::$details
     */
    function &GetAllAsReference()
    {
        return $this->details;
    }

    /**
     * GetId
     *
     * Liefert die Id des aktuellen Autors oder FALSE.
     *
     * @return string
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function GetId()
    {
        if ($this->LoggedIn())
            return $this->details['aid'];
        return false;
    }

    /**
     * GetPasswd
     *
     * Liefert den MD5-Wert des Kennworts oder FALSE
     *
     * @return string
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function GetPasswd()
    {
        if ($this->LoggedIn())
            return $this->details['pwd'];
        return false;
    }

    /**
     * GetLanguage
     *
     * Liefert die bevorzugte Sprache oder einen Leerstring.
     *
     * @return string
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function GetLanguage()
    {
        if ($this->logged_in)
        {
            $admlanguage = $this->details['admlanguage'];
            if (!empty($admlanguage) && file_exists('language/lang-' . vkpVarPrepForOs($admlanguage) . '.php'))
            {
                $result = $admlanguage;
                return $result;
            }
        }
        // Default Language berschreibt nicht die Admin-Einstellung
        //
        $result = '';
        return $result;
    }

    /**
     * GetName
     *
     * Liefert den Namen (wird nicht bentigt, da PHP-Nuke flschlicherweise die aid
     * benutzt.
     *
     * @return string
     * @author Hinrich Donner
     * @version 0.1
     * @since 5.5.1
     */
    function GetName()
    {
        if ($this->logged_in)
            return $this->details['name'];
        return '';
    }

    /**
     * GetUrl
     *
     * Liefert die URL des Autors.
     *
     * @return string
     * @author Hinrich Donner
     * @version 0.1
     * @since 5.5.1
     */
    function GetUrl()
    {
        if ($this->logged_in)
        {
            $result = $this->details['url'];
            if (!preg_match("/^(http:|https:|gopher:|wais:)/", $result))
                $result = 'http://' . $result;
        }
        else
            $result = '';
        return $result;
    }

    /**
     * GetMail
     *
     * Liefert die Mailadresse.
     *
     * @return string
     * @author Hinrich Donner
     * @version 0.1
     * @since 5.5.1
     */
    function GetMail()
    {
        if ($this->logged_in)
            return $this->details['email'];
        return '';
    }

    /**
     * HasFlag
     *
     * Testet, ob ein bestimmtes Flag gesetzt ist.
     *
     * @param string $flag Der Name des Flags (z.B. 'article' fr 'radminarticle')
     * @return string
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function HasFlag($flag)
    {
        // Feldnamen zusammensetzen
        //
        $flag_name = 'radmin' . $flag;

        // Sonderbehandlung des Superusers
        //
        if (($flag == 'super') || ($this->details['radminsuper'] == 1))
            return $this->details['radminsuper'];

        // Nachsehen, ob ein entsprechendes Feld existiert
        //
        if (array_key_exists($flag_name, $this->details))
            return $this->details[$flag_name];
        else
            return false;
    }

    /**
     * GetFlags
     *
     * Liefert ein Array mit allen Flags.
     *
     * @return array Die Flags
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
     function GetFlags()
     {
        $result = array();
        foreach ($this->details as $name => $value)
        {
            if (substr($name, 0, 6) == 'radmin')
                $result[$name] = $value;
        }
        return $result;
     }
}

// $Log: vkpadmin.php,v $
// Revision 1.3  2004/01/10 11:29:36  hdonner
// - vkpAdmin::GetFlags()
//
// Revision 1.2  2003/12/17 17:39:06  hdonner
// - Weitere Methoden
//
// Revision 1.1  2003/12/15 23:20:57  hdonner
// - Klasse vkpAdmin
//
//
?>
