<?php
// ----------------------------------------------------------------------
// File: $Id: vkpdbtable.php,v 1.2 2004/01/02 17:12:50 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------
error_reporting(E_ALL);
/**
 * vkpdbtable.php
 *
 * Diese Datei enthlt die Klasse vkpDbTable.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API (Klassen)
 * @category Benutzer
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * vkpDbTable
 * 
 * Abstrakte Klasse fr die Handhabung von SQL-Tabellen.
 * 
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @access protected
 * @abstract
 */
class vkpDbTable
{
    /**
     * _config
     * 
     * Eine Kopie der Instanz der Konfiguration.
     * 
     * @var vkpConfig
     * @access protected
     */
    var $_config;
    
    /**
     * names
     * 
     * Eine Liste mit den Feldnamen.
     * 
     * @var array
     * @access protected
     */
    var $_names;
    
    /**
     * tablename
     * 
     * Der Name der Tabelle.
     * 
     * @var string
     */
    var $tablename;
             
    /**
     * vkpDbTable
     * 
     * Konstruktor.
     *             
     * @param string $tablename Vollstndiger Name der Tabelle
     * @param array $fieldlist Ein Array mit den Feldbezeichnern
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function vkpDbTable($tablename, $fieldlist = false)
    {
        $this->_config =& vkpConfig::GetInstance();
        $this->tablename = $tablename;
        if (!is_array($fieldlist)) 
            $fieldlist = $this->_FetchFields();
        $this->_StoreFields($fieldlist);
    }

    /**
     * _FetchFields
     * 
     * Liest die Feldnamen aus der Datenbank
     * 
     * @return array
     * @access private
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function _FetchFields()
    {
        $db =& vkpSqlGetConn();
        $fields = $db->MetaColumnNames($this->tablename);
        return $fields;
    }
                    
    /**
     * _StoreFields
     * 
     * Erstellt Eigenschaften zu den Tabellenfeldern
     * 
     * @param array $names
     * @access private
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function _StoreFields(&$names)
    {
        foreach ($names as $name)
            $this->$name = null;
    }

    /**
     * ExistsVar
     * 
     * Prft, ob ein Tabellenfeld existiert
     * 
     * @param string $name Feldbezeichner
     * @return bool
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function ExistsVar($name)
    {
        return (!empty($name) && isset($this->$name));
    }
    
    /**
     * GetVar
     * 
     * Liefert eine Eigenschaft oder einen Vorgabewert      
     * 
     * @param string $name Name des Tabellenfeldes
     * @param mixed $default Der Vorgabewert
     * @return mixed
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function GetVar($name, $default = null)
    {
        if ($this->ExistsVar($name)) 
            return $this->$name;
        return $default;    
    }
}
 
// $Log: vkpdbtable.php,v $
// Revision 1.2  2004/01/02 17:12:50  hdonner
// - OOP-API Themes
//
// Revision 1.1  2003/12/26 15:26:14  hdonner
// - Benutzerfunktionen ausgelagert
// - Klasse vkpUser begonnen
//
//
?>