<?php
// ----------------------------------------------------------------------
// File: $Id: vkpreferer.php,v 1.1.2.1 2004/01/13 16:27:51 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * vkpreferer.php
 *
 * Diese Datei enthlt die Klasse vkpReferer.
 *
 * @author Hinrich Donner
 * @copyright Hinrich Donner 2003
 * @license GPL
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage System
 * @category Statistics
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

/**
 * vkpReferer
 *
 * Diese Klasse kmmert sich um die Referer.
 *
 * @author Hinrich Donner
 */
class vkpReferer
{
    /**
     * _added
     *
     * Sobald ein Referer eingefgt wurde, wird diese Eigenschaft auf TRUE gesetzt.
     *
     * @var bool
     * @access protected
     */
    var $_added = false;

    /**
     * include_locals
     *
     * Diese Eigenschaft legt fest, ob Referer von der eigenen Web-Site bercksichtigt
     * werden sollen.
     *
     * @var bool
     */
    var $include_locals;

    /**
     * vkpReferer
     *
     * Der Constructor fr diese Klasse.
     *
     * @param bool $include_locals TRUE, falls Referer von der eigenen Seite bercksichtigt werden sollen
     */
    function vkpReferer($include_locals = false)
    {
        $this->$include_locals = $include_locals;
    }

    /**
     * Add
     *
     * Fgt den angegebenen Referer in die Datenbank ein.
     *
     * @param string $referer Der Referer
     */
    function Add($referer)
    {
        // Suchmaske aufbauen
        //
        if ($this->include_locals)
            $search = "!^(unknown|bookmark)!i";
        else
        {
            $url = vkpGetBaseUrl();
            if (substr($url, strlen($url) - 1, 1) == '/')
                $url = substr($url, 0, strlen($url) - 1);
            $search = "!^(unknown|$url|bookmark|http://localhost)!i";
        }

        // Prfe, ob berhaupt etwas hinzugefgt werden soll.
        //
        if (empty($referer)
                || preg_match($search, $referer))
            return;

        $config =& vkpConfig::GetInstance();
        
        // Referer eintragen
        //
        $sql = "INSERT INTO `" . $config->prefix . "_referer`
                (`url`)
                VALUES ('" . substr(vkpVarPrepForStore($_SERVER['HTTP_REFERER']), 0, 100) . "')";
        sql_query($sql);
        $this->_added = true;
    }

    /**
     * Count
     *
     * Liefert die Anzahl der in der Tabelle gespeicherten Referers.
     *
     * @return int
     */
    function Count()
    {
        $config =& vkpConfig::GetInstance();

        $dbr = sql_query("SELECT COUNT(`rid`)
                          FROM `" . $config->prefix . "_referer`");
        list($numrows) = sql_fetch_row($dbr);
        sql_free_result($dbr);
        return $numrows;
    }

    /**
     * Shrink
     *
     * Reduziert die Datenbankeintrge auf die angegebene Gre. Wenn $force
     * auf FALSE steht, dann wird die Aktion nur ausgefhrt, sofern vorher
     * mindestens ein Referer eingetragen wurde.
     *
     * @param int $leave Anzahl der Datenstze, die in der Tabelle verbleiben sollen
     * @param bool force Wenn TRUE, dann wird die Aktion immer durchgefhrt
     */
    function Shrink($leave, $force = false)
    {
        if (!$this->_added && !$force)
            return;

        $total = $this->Count();
        $leave = (int) $leave;

        if ($total <= $leave)
            return;

        $config =& vkpConfig::GetInstance();

        $limit  = $total - $leave;
        $sql    = "SELECT `rid`
                   FROM `" . $config->prefix . "_referer`
                   ORDER BY `rid` ASC
                   LIMIT 0, $limit";

        $dbr = sql_query($sql, $dbi);
        while (false !== ($item = sql_fetch_array($dbr)))
        {
            sql_query("DELETE FROM `" . $config->prefix . "_referer`
                       WHERE `rid`='" . vkpVarPrepForStore($item['rid']) . "'");
        }
        sql_free_result($dbr);
    }
}

// $Log: vkpreferer.php,v $
// Revision 1.1.2.1  2004/01/13 16:27:51  hdonner
// - Fix #1342
//
// Revision 1.1  2003/11/11 20:44:27  hdonner
// - Referer Behandlung
//
//
?>
