<?php
// ----------------------------------------------------------------------
// File: $Id: vkpuser.php,v 1.3 2004/01/02 17:12:50 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * vkpuser.php
 *
 * Diese Datei enthlt die Klasse vkpUser.
 *
 * @author Hinrich Donner
 * @version 0.2
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API (Klassen)
 * @category Benutzer
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */
error_reporting(E_ALL);
/**
 * Klassen einbinden
 * 
 * @ignore
 */
require_once VKP_INCLUDE_DIR . '/classes/vkpmember.php';
 
/**
 * __VKP_USER_INSTANCE
 *
 * Der Name der globalen Variablen, die die Instance enthlt.
 *
 * @access private
 * @see vkpUser
 */
define('__VKP_USER_INSTANCE', '__vkp_user_instance');

/**
 * Klasse vkpUser
 *
 * Diese Klasse enthlt die notwendigen Methoden fr die Zugriffe auf
 * die Eigenschaften des aktuellen Benutzers.
 *
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @see vkpMember, vkpDbTable
 */
class vkpUser extends vkpMember
{
    /**
     * logged_in
     *
     * Enthlt den Status des aktuellen Benutzers.
     *
     * @var bool
     * @access public
     */
    var $logged_in = false;

    /**
     * vkpUser
     *
     * Konstruktor
     *
     * @access protected
     * @see vkpUser::GetInstance()
     * @version 0.2
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function vkpUser()
    {
        // Konstruktor
        //
        $this->vkpMember();
        
        // Auto-Login
        //
        if ($this->_LoginBySession())
            return;
        elseif ($this->_LoginByCookie())
            return;
        $this->Init();
    }

    /**
     * GetInstance
     *
     * Liefert eine Referenz auf die Instanz der Klasse. Diese Funktion sollte unbedingt
     * anstelle des Konstruktors benutzt werden, da so sichergestellt wird, dass nur eine
     * Instanz angelegt wird.
     *
     * @return vkpUser Die Referenz
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function &GetInstance()
    {
        if (!array_key_exists(__VKP_USER_INSTANCE, $GLOBALS) || !is_a($GLOBALS[__VKP_USER_INSTANCE], 'vkpUser'))
            $GLOBALS[__VKP_USER_INSTANCE] =& new vkpUser();
        return $GLOBALS[__VKP_USER_INSTANCE];
    }

    /**
     * LoadById
     *
     * Ld einen Datensatz, wobei die Id als Suchkriterium verwendet wird.  Es besteht
     * im Normallfall keine Notwendigkeit, diese Methode zu benutzen.
     *
     * @param int $id Die id
     * @param string $passwd Das Kennwort
     * @version 0.2
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function LoadById($id, $passwd)
    {
		// Datensatz lesen
		//
		if (false === ($result = parent::LoadById($id, false)))
			return false;

		// Die Daten nur bei einem korrektem Kennwort zurckgeben
		//		
		if (empty($passwd) || ($result['pass'] != $passwd))
			return false;

        return $result;
    }

    /**
     * _LogInBySession
     *
     * Diese Methode prft, ob eine Session-Variable mit der Id existiert. Falls ja,
     * wird der zugehrige Datensatz geladen.
     *
     * @return bool
     * @access protected
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function _LoginBySession()
    {
        $session =& psSession::GetInstance();
        if (!$session->Exists('__vkp_user_id') || !$session->Exists('__vkp_user_passwd'))
            return false;
        $this->Free();
        $this->Init($this->LoadById($session->Get('__vkp_user_id'),
                                    $session->Get('__vkp_user_passwd')));
        return true;
    }

    /**
     * _LogInByCookie
     *
     * Diese Methode prft, ob ein gltiges Cookie vorhanden ist. Falls ja, wird ein Login
     * durchgefhrt.
     *
     * @return bool
     * @access protected
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner                
     * @todo Verwendung des Cookie konfigurierbar
     */
    function _LoginByCookie()
    {
        $config =& vkpConfig::GetInstance();
        if (!vkpCookieExists('user'))
            return false;
        $user = vkpCookieGet('user');
        $user = base64_decode($user);
        list($id,
			 $uname,
             $passwd,
             $rest) = split(':', $user, 4);
        $details = $this->LoadById($id, $passwd);
        if (empty($details)
                || empty($passwd)
                || !is_array($details)
                || !array_key_exists('pass', $details)
                || ($passwd !== $details['pass']))
            return false;
        $this->Free();
        $this->Init($details);
        $this->UpdateSession();

        // Cookie erneuern
        //
        $op = vkpVarCleanFromInput('op');
        if (!empty($op) && ($op != 'logout'))
            vkpCookieSet('user',
                         base64_encode($user),
                         $config->user_cookie_lifetime);
        return true;
    }

    /**
     * UpdateSession
     *
     * Diese Methode aktualisiert die Session-Daten.
     *
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     */
    function UpdateSession()
    {
        $session =& psSession::GetInstance();
        if ($this->logged_in)
        {
            $session->Set('__vkp_user_id', $this->GetId());
            $session->Set('__vkp_user_passwd', $this->GetPasswd());
        }
        else
        {
            $session->Delete('__vkp_user_id');
            $session->Delete('__vkp_user_passwd');
        }
    }

    /**
     * Init
     *
     * Diese Methode initialisiert den Speicherbereich.
     *
     * @param array $source Der zu kopierende Datensatz
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpMember::Free(), vkpMember::Clear()
     */
    function Init($source = array())
    {
		parent::Init(&$source);
        if (is_array($source) && array_key_exists('uid', $source))
        {
            // Eigenschaften erzeugen
            //
            foreach ($this->details as $name => $value)
                $this->$name = $value;

            $this->logged_in = true;
        }
        else
        {
            $config =& vkpConfig::GetInstance();
            $this->logged_in    = false;
            $this->uid          = 0;
            $this->uname        = $config->anonymous;
        }
    }

    /**
     * LoggedIn
     *
     * Diese Methode liefert den Wert der Eigenschaft logged_in
     *
     * @return bool
     * @version 0.1
     * @since 5.5.1
     * @author Hinrich Donner
     * @see vkpUser::$logged_in
     */
    function LoggedIn()
    {
        return $this->logged_in;
    }
}

// $Log: vkpuser.php,v $
// Revision 1.3  2004/01/02 17:12:50  hdonner
// - OOP-API Themes
//
// Revision 1.2  2003/12/31 17:02:34  hdonner
// - User: OOP-API
//
// Revision 1.1  2003/12/26 15:26:14  hdonner
// - Benutzerfunktionen ausgelagert
// - Klasse vkpUser begonnen
//
//
?>