<?php
// ----------------------------------------------------------------------
// File: $Id: theme-extension.php,v 1.1 2003/12/08 16:41:43 hdonner Exp $
// ----------------------------------------------------------------------
// PHP-Nuke-VKP
// Copyright 2001-2004 by PHP-Nuke-VKP-Team
// http://developer.berlios.de/projects/phpnukevkp/
// ----------------------------------------------------------------------
// LICENSE
//
// Dieses Programm ist freie Software; Sie knnen sie beliebig verteilen
// und/oder nderungen vornehmen, solange Sie dieses unter den
// Lizenzbedingungen der Version 2 oder hher der GNU General Public
// License (GPL), verffentlicht von der Free Software Foundation tun.
//
// Dieses Programm wurde in der Hoffnung erstellt, dass es fr Sie
// ntzlich sein knnte. Es wird jedoch ohne jeden Anspruch auf
// Gewhrleistung verffentlicht. Sie knnen auch nicht davon ausgehen,
// dass das Programm Dinge verrichtet, wie es erwartet wird.
//
// Lesen Sie die Lizenzbedinguneg unter der URL
// http://www.gnu.org/copyleft/gpl.html fr weitere Details.
// ----------------------------------------------------------------------

/**
 * themes-extension.php
 *
 * Diese Datei enthlt die Funktionen, die bei PHP-Nuke flschlicher
 * Weise in der mainfile.php deklariert sind. Sie wird automatisch
 * eingebunden. Wenn ein Theme die entsprechenden Funktionen nicht
 * definiert hat, so werden sie hier definiert.
 *
 * @see title(), themepreview(), themecenterbox()
 * @see vkpThemeInclude()
 * @author Hinrich Donner
 * @version 0.1
 * @since 5.5.1
 * @package PHP-Nuke-VKP
 * @subpackage API
 * @category Themes
 * @link http://developer.berlios.de/projects/phpnukevkp/
 */

if (!function_exists('themecenterbox'))
{
    /**
     * Theme Center Box
     *
     * Gibt einen zentrierten Block aus. Warum F. Bruzi diese Funktion nicht unter
     * den Themes deklariert hat, bleibt ein Geheimnis.
     *
     * @param string $title Der Titel
     * @param string $content Der Blockinhalt
     * @see themesidebox()
     * @author F. Bruzi
     * @version 0.1
     * @since 5.5.1
     */
    function themecenterbox($title, $content)
    {
        OpenTable();
        echo "<div align=\"center\"><div class=\"option\"><b>$title</b></div></div><br>"
            ."$content";
        CloseTable();
        echo "<br>";
    }
}

if (!function_exists('themepreview'))
{
    /**
     * themepreview
     *
     * Diese Funktion erstellt eine (bescheidene) Vorschau auf einen Artikel.
     * Auch diese Funktion gehrt eigentlich zu den Themes.
     *
     * @author F. Bruzi
     * @version 0.1
     * @since 5.5.1
     */
    function themepreview($title, $hometext, $bodytext="", $notes="")
    {
        echo "<b>$title</b><br><br>$hometext";
        if ($bodytext != "") {
        echo "<br><br>$bodytext";
        }
        if ($notes != "") {
        echo "<br><br><b>"._NOTE."</b> <i>$notes</i>";
        }
    }
}

if (!function_exists('title'))
{
    /**
     * title
     *
     * Gibt einen Text als Titel aus. Warum F. Bruzi diese Funktion nicht unter
     * den Themes deklariert hat, bleibt ein Geheimnis.
     *
     * @param string $text
     * @author F. Bruzi
     * @version 0.2
     * @since 5.5.1
     */
    function title($text)
    {
        OpenTable();
        echo '<div align="center" id="center"><div class="title"><b>' . $text . '</b></div></div>';
        CloseTable();
        echo "<br>\n";
    }
}
// $Log: theme-extension.php,v $
// Revision 1.1  2003/12/08 16:41:43  hdonner
// - Themes-Backcore angepasst
//
//
?>
